
type Text   = List[String]

case class Pos(line: Int, col: Int)

case class Editor(text: Text, cursor: Pos) {

  def left: Editor =
    if (cursor.col == 0) sys.error("At start of line")
    else Editor(text, cursor.copy(col = cursor.col - 1))

  def right: Editor =
    if (cursor.col == text(cursor.line).length) sys.error("At end of line")
    else Editor (text, cursor.copy(col= cursor.col+ 1))


  private def updCurLine(newLine: String): List[String] =
    text.take(cursor.line) ++ (newLine :: text.drop(cursor.line+ 1))

  def insert(s: String): Editor = {
    val (befor,after) = text(cursor.line).splitAt(cursor.col)
    Editor(updCurLine(befor+ s+ after),cursor.copy(col= cursor.col+1))
  }

  def delete: Editor = {
    val (before, after)= text(cursor.line).splitAt(cursor.col)
    val newCol = if ((cursor.col == text(cursor.line).length) && cursor.col > 0)
                 cursor.col- 1 else cursor.col
    Editor(updCurLine(before+ after.drop(1)), cursor.copy(col= newCol))
  }


}

