-- Lists with functional update

data List a = Nil | Cons a (List a)
              deriving Show

-- This context type is actually List a!
data Ctxt a = Empty | Snoc (Ctxt a) a

-- So instead of this:
newtype Loc1 a = Loc1 (List a, Ctxt a)
-- we can have:
newtype Loc a = Loc (List a, List a)

top :: List a-> Loc a
top xs = Loc (xs, Nil)

-- Allowing us to write:
fastrev1 :: List a-> List a
fastrev1 xs = rev (top xs) where
  rev :: Loc a-> List a
  rev (Loc(Nil, as))       = as
  rev (Loc(Cons x xs, as)) = rev (Loc (xs, Cons x as))

-- Note this is the same as the usual:
fastrev2 :: [a]-> [a]
fastrev2 xs = rev xs [] where
  rev :: [a]-> [a]-> [a]
  rev []     as = as
  rev (x:xs) as = rev xs (x:as)
