
sealed trait List[+A]
case object Nil extends List[Nothing]
case class Cons[A](head: A, tail: List[A]) 
  extends List[A]

sealed trait Context[+A]
case object Empty extends Context[Nothing]
case class Snoc[A](init: Context[A], last: A) 
  extends Context[A]


object List {
  def rev[A](l: List[A], init: List[A] = Nil): List[A] = l match {
    case Nil   => init
    case Cons(x, xs) => rev(xs, Cons(x, init))
  }
}


